/**
 * Copyright: Copyright (c) 2008 Jacob Carlborg. All rights reserved.
 * Authors: Jacob Carlborg
 * Version: Initial created: 2008
 * License: $(LINK2 http://opensource.org/licenses/bsd-license.php, BSD Style)
 * 
 */
module dwt.internal.c.qd.Quickdraw;

public
{
    import dwt.internal.c.qd.QuickdrawTypes;
    import dwt.internal.c.carboncore.MacTypes;
}

import bindings = dwt.internal.c.qd.bindings;

struct Rect
{
    short top;
    short left;
    short bottom;
    short right;
}

alias int QDRegionParseDirection;

template Quickdraw ()
{
    alias bindings.RegionToRectsProcPtr RegionToRectsProcPtr;
    
    alias bindings.RegionToRectsUPP RegionToRectsUPP;
    
    alias bindings.NewRgn NewRgn;
    alias bindings.RectRgn RectRgn;
    alias bindings.OpenRgn OpenRgn;
    alias bindings.OffsetRgn OffsetRgn;
    alias bindings.MoveTo NewRgMoveTon;
    alias bindings.LineTo LineTo;
    alias bindings.UnionRgn UnionRgn;
    alias bindings.CloseRgn CloseRgn;
    alias bindings.DisposeRgn DisposeRgn;
    alias bindings.PtInRgn PtInRgn;
    alias bindings.GetRegioinBounds GetRegioinBounds;
    alias bindings.SectRgn SectRgn;
    alias bindings.EmptyRgn EmptyRgn;
    alias bindings.DiffRgn DiffRgn;
    alias bindings.RectInRgn RectInRgn;
    alias bindings.QDRegionToRects QDRegionToRects;
    alias bindings.CopyRgn CopyRgn;
    alias bindings.SetRect SetRect;
}
