/*******************************************************************************
 * Copyright (c) 2007 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *     
 * Port to the D Programming language:
 *     Jacob Carlborg <jacob.carlborg@gmail.com>
 *******************************************************************************/
module dwt.internal.cocoa.NSColorWell;

import dwt.internal.cocoa.NSColor;
import dwt.internal.cocoa.NSObject;
import dwt.internal.cocoa.NSRect;
import dwt.internal.cocoa.OS;
import objc = dwt.internal.objc.runtime;

public class NSColorWell : NSControl
{

    public this ()
    {
        super();
    }

    public this (objc.id id)
    {
        super(id);
    }

    public void activate (bool exclusive)
    {
        OS.objc_msgSend(this.id, OS.sel_activate_1, exclusive);
    }

    public NSColor color ()
    {
        objc.id result = OS.objc_msgSend(this.id, OS.sel_color);
        return result !is null ? new NSColor(result) : null;
    }

    public void deactivate ()
    {
        OS.objc_msgSend(this.id, OS.sel_deactivate);
    }

    public void drawWellInside (NSRect insideRect)
    {
        OS.objc_msgSend(this.id, OS.sel_drawWellInside_1, insideRect);
    }

    public bool isActive ()
    {
        return OS.objc_msgSend(this.id, OS.sel_isActive) !is null;
    }

    public bool isBordered ()
    {
        return OS.objc_msgSend(this.id, OS.sel_isBordered) !is null;
    }

    public void setBordered (bool flag)
    {
        OS.objc_msgSend(this.id, OS.sel_setBordered_1, flag);
    }

    public void setColor (NSColor color)
    {
        OS.objc_msgSend(this.id, OS.sel_setColor_1, color !is null ? color.id : null);
    }

    public void takeColorFrom (id sender)
    {
        OS.objc_msgSend(this.id, OS.sel_takeColorFrom_1, sender !is null ? sender.id : null);
    }

}
