/*******************************************************************************
 * Copyright (c) 2007 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *     
 * Port to the D Programming language:
 *     Jacob Carlborg <jacob.carlborg@gmail.com>
 *******************************************************************************/
module dwt.internal.cocoa.NSDirectoryEnumerator;

import dwt.internal.cocoa.NSDictionary;
import dwt.internal.cocoa.NSEnumerator;
import dwt.internal.cocoa.OS;
import objc = dwt.internal.objc.runtime;

public class NSDirectoryEnumerator : NSEnumerator
{
    public this ()
    {
        super();
    }

    public this (objc.id id)
    {
        super(id);
    }

    public NSDictionary directoryAttributes ()
    {
        objc.id result = OS.objc_msgSend(this.id, OS.sel_directoryAttributes);
        return result !is null ? new NSDictionary(result) : null;
    }

    public NSDictionary fileAttributes ()
    {
        objc.id result = OS.objc_msgSend(this.id, OS.sel_fileAttributes);
        return result !is null ? new NSDictionary(result) : null;
    }

    public void skipDescendents ()
    {
        OS.objc_msgSend(this.id, OS.sel_skipDescendents);
    }
}
