/*******************************************************************************
 * Copyright (c) 2007 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *     
 * Port to the D Programming language:
 *     Jacob Carlborg <jacob.carlborg@gmail.com>
 *******************************************************************************/
module dwt.internal.cocoa.NSDistantObject;

import dwt.internal.cocoa.id;
import dwt.internal.cocoa.NSConnection;
import dwt.internal.cocoa.NSProxy;
import dwt.internal.cocoa.OS;
import objc = dwt.internal.objc.runtime;

public class NSDistantObject : NSProxy
{

    public this ()
    {
        super();
    }

    public this (objc.id id)
    {
        super(id);
    }

    public NSConnection connectionForProxy ()
    {
        objc.id result = OS.objc_msgSend(this.id, OS.sel_connectionForProxy);
        return result !is null ? new NSConnection(result) : null;
    }

    public id initWithLocal (id target, NSConnection connection)
    {
        objc.id result = OS.objc_msgSend(this.id, OS.sel_initWithLocal_1connection_1, target !is null ? target.id : null,
                connection !is null ? connection.id : null);
        return result !is null ? new id(result) : null;
    }

    public id initWithTarget (id target, NSConnection connection)
    {
        objc.id result = OS.objc_msgSend(this.id, OS.sel_initWithTarget_1connection_1, target !is null ? target.id : null,
                connection !is null ? connection.id : null);
        return result !is null ? new id(result) : null;
    }

    public static NSDistantObject proxyWithLocal (id target, NSConnection connection)
    {
        objc.id result = OS.objc_msgSend(OS.class_NSDistantObject, OS.sel_proxyWithLocal_1connection_1, target !is null ? target.id : null,
                connection !is null ? connection.id : null);
        return result !is null ? new NSDistantObject(result) : null;
    }

    public static NSDistantObject proxyWithTarget (id target, NSConnection connection)
    {
        objc.id result = OS.objc_msgSend(OS.class_NSDistantObject, OS.sel_proxyWithTarget_1connection_1, target !is null ? target.id : null,
                connection !is null ? connection.id : null);
        return result !is null ? new NSDistantObject(result) : null;
    }

//PUBLIC VOID SETPROTOCOLFORPROXY(PROTOCOL PROTO) {
//  OS.OBJC_MSGSEND(THIS.ID, OS.SEL_SETPROTOCOLFORPROXY_1, PROTO !is NULL ? PROTO.ID : null);
//}

}
