/*******************************************************************************
 * Copyright (c) 2007 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *     
 * Port to the D Programming language:
 *     Jacob Carlborg <jacob.carlborg@gmail.com>
 *******************************************************************************/
module dwt.internal.cocoa.NSMutableIndexSet;

import dwt.internal.cocoa.NSIndexSet;
import dwt.internal.cocoa.NSInteger;
import dwt.internal.cocoa.NSRange;
import dwt.internal.cocoa.OS;
import objc = dwt.internal.objc.runtime;

public class NSMutableIndexSet : NSIndexSet
{

    public this ()
    {
        super();
    }

    public this (objc.id id)
    {
        super(id);
    }

    public void addIndex (NSUInteger value)
    {
        OS.objc_msgSend(this.id, OS.sel_addIndex_1, value);
    }

    public void addIndexes (NSIndexSet indexSet)
    {
        OS.objc_msgSend(this.id, OS.sel_addIndexes_1, indexSet !is null ? indexSet.id : null);
    }

    public void addIndexesInRange (NSRange range)
    {
        OS.objc_msgSend(this.id, OS.sel_addIndexesInRange_1, range);
    }

    public void removeAllIndexes ()
    {
        OS.objc_msgSend(this.id, OS.sel_removeAllIndexes);
    }

    public void removeIndex (NSUInteger value)
    {
        OS.objc_msgSend(this.id, OS.sel_removeIndex_1, value);
    }

    public void removeIndexes (NSIndexSet indexSet)
    {
        OS.objc_msgSend(this.id, OS.sel_removeIndexes_1, indexSet !is null ? indexSet.id : null);
    }

    public void removeIndexesInRange (NSRange range)
    {
        OS.objc_msgSend(this.id, OS.sel_removeIndexesInRange_1, range);
    }

    public void shiftIndexesStartingAtIndex (NSUInteger index, NSInteger delta)
    {
        OS.objc_msgSend(this.id, OS.sel_shiftIndexesStartingAtIndex_1by_1, index, delta);
    }

}
