/*******************************************************************************
 * Copyright (c) 2007 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *     
 * Port to the D Programming language:
 *     Jacob Carlborg <jacob.carlborg@gmail.com>
 *******************************************************************************/
module dwt.internal.cocoa.NSNib;

import dwt.internal.cocoa.id;
import dwt.internal.cocoa.NSBundle;
import dwt.internal.cocoa.NSDictionary;
import dwt.internal.cocoa.NSObject;
import dwt.internal.cocoa.NSString;
import dwt.internal.cocoa.NSURL;
import dwt.internal.cocoa.OS;
import objc = dwt.internal.objc.runtime;

public class NSNib : NSObject
{

    public this ()
    {
        super();
    }

    public this (objc.id id)
    {
        super(id);
    }

    public id initWithContentsOfURL (NSURL nibFileURL)
    {
        objc.id result = OS.objc_msgSend(this.id, OS.sel_initWithContentsOfURL_1, nibFileURL !is null ? nibFileURL.id : null);
        return result !is null ? new id(result) : null;
    }

    public id initWithNibNamed (NSString nibName, NSBundle bundle)
    {
        objc.id result = OS.objc_msgSend(this.id, OS.sel_initWithNibNamed_1bundle_1, nibName !is null ? nibName.id : null,
                bundle !is null ? bundle.id : null);
        return result !is null ? new id(result) : null;
    }

    public bool instantiateNibWithExternalNameTable (NSDictionary externalNameTable)
    {
        return OS.objc_msgSend(this.id, OS.sel_instantiateNibWithExternalNameTable_1, externalNameTable !is null ? externalNameTable.id : null) !is null;
    }

    public bool instantiateNibWithOwner (id owner, objc.id** topLevelObjects)
    {
        return OS.objc_msgSend(this.id, OS.sel_instantiateNibWithOwner_1topLevelObjects_1, owner !is null ? owner.id : null, topLevelObjects) !is null;
    }

}
