/*******************************************************************************
 * Copyright (c) 2007 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *     
 * Port to the D Programming language:
 *     Jacob Carlborg <jacob.carlborg@gmail.com>
 *******************************************************************************/
module dwt.internal.cocoa.NSPathComponentCell;

import dwt.internal.cocoa.NSImage;
import dwt.internal.cocoa.NSTextFieldCell;
import dwt.internal.cocoa.NSURL;
import dwt.internal.cocoa.OS;
import objc = dwt.internal.objc.runtime;

public class NSPathComponentCell : NSTextFieldCell
{

    public this ()
    {
        super();
    }

    public this (objc.id id)
    {
        super(id);
    }

    public NSURL URL ()
    {
        objc.id result = OS.objc_msgSend(this.id, OS.sel_URL);
        return result !is null ? new NSURL(result) : null;
    }

    public NSImage image ()
    {
        objc.id result = OS.objc_msgSend(this.id, OS.sel_image);
        return result !is null ? new NSImage(result) : null;
    }

    public void setImage (NSImage value)
    {
        OS.objc_msgSend(this.id, OS.sel_setImage_1, value !is null ? value.id : null);
    }

    public void setURL (NSURL url)
    {
        OS.objc_msgSend(this.id, OS.sel_setURL_1, url !is null ? url.id : null);
    }

}
