/*******************************************************************************
 * Copyright (c) 2007 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *     
 * Port to the D Programming language:
 *     Jacob Carlborg <jacob.carlborg@gmail.com>
 *******************************************************************************/
module dwt.internal.cocoa.NSStatusBar;

import dwt.internal.cocoa.CGFloat;
import dwt.internal.cocoa.NSObject;
import dwt.internal.cocoa.NSStatusItem;
import dwt.internal.cocoa.OS;
import objc = dwt.internal.objc.runtime;

public class NSStatusBar : NSObject
{

    public this ()
    {
        super();
    }

    public this (objc.id id)
    {
        super(id);
    }

    public bool isVertical ()
    {
        return OS.objc_msgSend(this.id, OS.sel_isVertical) !is null;
    }

    public void removeStatusItem (NSStatusItem item)
    {
        OS.objc_msgSend(this.id, OS.sel_removeStatusItem_1, item !is null ? item.id : null);
    }

    public NSStatusItem statusItemWithLength (CGFloat length)
    {
        objc.id result = OS.objc_msgSend(this.id, OS.sel_statusItemWithLength_1, length);
        return result !is null ? new NSStatusItem(result) : null;
    }

    public static NSStatusBar systemStatusBar ()
    {
        objc.id result = OS.objc_msgSend(OS.class_NSStatusBar, OS.sel_systemStatusBar);
        return result !is null ? new NSStatusBar(result) : null;
    }

    public CGFloat thickness ()
    {
        return cast(CGFloat) OS.objc_msgSend_fpret(this.id, OS.sel_thickness);
    }

}
