module dwt.internal.cocoa;

public class WebFrameView : NSObject {

public WebFrameView() {
    super();
}

public WebFrameView(int id) {
    super(id);
}

public bool allowsScrolling() {
    return OS.objc_msgSend(this.id, OS.sel_allowsScrolling) !is 0;
}

public bool canPrintHeadersAndFooters() {
    return OS.objc_msgSend(this.id, OS.sel_canPrintHeadersAndFooters) !is 0;
}

public NSView  documentView() {
    int result = OS.objc_msgSend(this.id, OS.sel_documentView);
    return result !is 0 ? new NSView (result) : null;
}

public bool documentViewShouldHandlePrint() {
    return OS.objc_msgSend(this.id, OS.sel_documentViewShouldHandlePrint) !is 0;
}

public void printDocumentView() {
    OS.objc_msgSend(this.id, OS.sel_printDocumentView);
}

public NSPrintOperation printOperationWithPrintInfo(NSPrintInfo printInfo) {
    int result = OS.objc_msgSend(this.id, OS.sel_printOperationWithPrintInfo_1, printInfo !is null ? printInfo.id : 0);
    return result !is 0 ? new NSPrintOperation(result) : null;
}

public void setAllowsScrolling(bool flag) {
    OS.objc_msgSend(this.id, OS.sel_setAllowsScrolling_1, flag);
}

public WebFrame webFrame() {
    int result = OS.objc_msgSend(this.id, OS.sel_webFrame);
    return result !is 0 ? new WebFrame(result) : null;
}

}
